- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

EVP_SIGNATURE_fetch, EVP_SIGNATURE_free, EVP_SIGNATURE_up_ref, EVP_SIGNATURE_number, EVP_SIGNATURE_is_a, EVP_SIGNATURE_provider, EVP_SIGNATURE_do_all_provided, EVP_SIGNATURE_names_do_all - Functions to manage EVP_SIGNATURE algorithm objects

# SYNOPSIS

     #include <openssl/evp.h>

     EVP_SIGNATURE *EVP_SIGNATURE_fetch(OPENSSL_CTX *ctx, const char *algorithm,
                                        const char *properties);
     void EVP_SIGNATURE_free(EVP_SIGNATURE *signature);
     int EVP_SIGNATURE_up_ref(EVP_SIGNATURE *signature);
     int EVP_SIGNATURE_number(const EVP_SIGNATURE *signature);
     int EVP_SIGNATURE_is_a(const EVP_SIGNATURE *signature, const char *name);
     OSSL_PROVIDER *EVP_SIGNATURE_provider(const EVP_SIGNATURE *signature);
     void EVP_SIGNATURE_do_all_provided(OPENSSL_CTX *libctx,
                                        void (*fn)(EVP_SIGNATURE *signature,
                                                   void *arg),
                                        void *arg);
     void EVP_SIGNATURE_names_do_all(const EVP_SIGNATURE *signature,
                                     void (*fn)(const char *name, void *data),
                                     void *data);

# DESCRIPTION

`EVP_SIGNATURE_fetch()` fetches the implementation for the given algorithm from any provider offering it, within the criteria given by the properties. The algorithm will be one offering functions for performing signature related tasks such as signing and verifying. See provider(7)/Fetching algorithms for further information.

The returned value must eventually be freed with `EVP_SIGNATURE_free()`.

`EVP_SIGNATURE_free()` decrements the reference count for the EVP_SIGNATURE structure. Typically this structure will have been obtained from an earlier call to `EVP_SIGNATURE_fetch()`. If the reference count drops to 0 then the structure is freed.

`EVP_SIGNATURE_up_ref()` increments the reference count for an EVP_SIGNATURE structure.

`EVP_SIGNATURE_is_a()` returns 1 if signature is an implementation of an algorithm that's identifiable with name, otherwise 0.

`EVP_SIGNATURE_provider()` returns the provider that signature was fetched from.

`EVP_SIGNATURE_do_all_provided()` traverses all SIGNATURE implemented by all activated roviders in the given library context libctx, and for each of the implementations, calls the given function fn with the implementation method and the given arg as argument.

`EVP_SIGNATURE_number()` returns the internal dynamic number assigned to signature.

`EVP_SIGNATURE_names_do_all()` traverses all names for signature, and calls fn with each name and data.

# RETURN VALUES

`EVP_SIGNATURE_fetch()` returns a pointer to an EVP_SIGNATURE for success or NULL for failure.

`EVP_SIGNATURE_up_ref()` returns 1 for success or 0 otherwise.

# SEE ALSO

provider(7)/Fetching algorithms, OSSL_PROVIDER(3)

# HISTORY

The functions described here were added in OpenSSL 3.0.

# COPYRIGHT

Copyright 2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.